#include "mwutil.h"

void _setcursortype (int type)
{
#if defined(MSDOS)
  unsigned shape;
  SWI_REGS regs;

  switch (type)
  {
    case _NOCURSOR:
         shape = 0x2000;
         break;
    case _SOLIDCURSOR:
         shape = 0x0007;
         break;
    default:
         shape = 0x0607;
         break;
  }
  regs.eax = 0x100;  /* !! should be 0x0100 + _mw_ti.currmode */
  regs.ecx = shape;
  _dx_real_int (0x10, &regs);

#elif defined(WIN32)
  CONSOLE_CURSOR_INFO cci;

  switch (type)
  {
    case _NOCURSOR:
         cci.bVisible = FALSE;
         break;
    case _SOLIDCURSOR:
         cci.bVisible = TRUE;
         cci.dwSize = 100;
         break;
    default:
         cci.bVisible = TRUE;
         cci.dwSize = 10;
         break;
  }
  SetConsoleCursorInfo (_mw_hStdout, &cci);
#endif
}

