#include "mwutil.h"

#if defined(WIN32)
void delay (unsigned int msec)
{
  Sleep (msec);
}

#elif defined(__HIGHC__) || defined(__DMC__)
void delay (unsigned int msec)
{
  SetHiResTimer();      /* set timer-1 in mode 2 */

  for (; msec; msec--)
  {
    DWORD now = GetMilliSec();
    while (GetMilliSec() == now)   /* wait 1msec */
       ;
  }
}
#endif
