include mwutil.ah

PUBLIC @kbhit_intern, @mw_kbhit

_DATA segment
      extrn @char_avail : dword
      extrn @yield_proc : dword
      extrn @dpmi_yield : dword
_DATA ends

_TEXT segment

;
; int kbhit_intern (void);
;
@kbhit_intern:
        cmp   @dpmi_yield, 0  ; do we want yielding
        jne   @do_yield       ; yes, check yield_proc

@chk_stdin:
        push  edi             ; push regs just in case
        push  esi
        push  ebx
        mov   ah, 0Bh         ; Check Standard Input Status
        int   21h             ; AL = FFh if character available
        movzx eax, al
        pop   ebx
        pop   esi
        pop   edi
        ret

@do_yield:
        cmp   @yield_proc, 0
        je    @chk_stdin
        pushad
        call  [@yield_proc]
        popad
        jmp   short @chk_stdin

;
; int @mw_kbhit (void)
;
@mw_kbhit:
        cmp @char_avail, 0
        je  @kbhit_intern
        mov eax, 1
        ret

_TEXT ends
end
