#include <stdio.h>
#include <stdlib.h>
#if !defined(WIN32)
#include <dos.h>
#endif
#include <conio.h>

#if defined(__HIGHC__) || defined(__WATCOMC__) || defined(__DMC__) || defined(WIN32)
#include <mw/conio.h>
#endif

#undef nosound

long dummy_array[] = {
#if !defined(WIN32)
     (long)&directvideo,  (long)&directcursor,
     (long)&dpmi_yield,   (long)&_wscroll,
     (long)&_near_screen, (long)&outportb,
     (long)&outport,      (long)&inportb,
     (long)&inport,       (long)&sound,
     (long)&nosound,
#if !defined(__DMC__)
     (long)&outp,         (long)&inp,
     (long)&outpw,        (long)&inpw,
#endif
#endif
     (long)&cgets,        (long)&cprintf,
     (long)&cputs,        (long)&cscanf,
     (long)&clreol,       (long)&clrscr,
     (long)&delline,      (long)&putch,
     (long)&getche,       (long)&ungetch,
     (long)&highvideo,    (long)&insline,
     (long)&lowvideo,     (long)&normvideo,
     (long)&blinkvideo,   (long)&intensevideo,
     (long)&textattr,     (long)&textbackground,
     (long)&textcolor,    (long)&textmode,
     (long)&gettextinfo,  (long)&window,
     (long)&puttext,      (long)&movetext,
     (long)&gotoxy,       (long)&wherex,
     (long)&wherey,       (long)&delay,
     (long)&kbhit,        (long)&getch,
     (long)&_setcursortype
   };

int main (int argc, char **argv)
{
  struct text_info ti;
  long   a = 0, b = dummy_array[0];
  long   c = 0, d = 0;
  int    rc, ch, x;
  char   buf[50];

#if (defined(__HIGHC__) || defined(__WATCOMC__)) && defined(MSDOS)
  if (argc > 1 && argv[1][0] == 'n')
     _near_screen = 0;
#endif

  gettextinfo (&ti);

  textattr (BLACK+16*LIGHTGRAY);
  window (1, 8, 80, ti.screenheight-3);
  clrscr();

  textattr (WHITE+16*BLUE);
  window (2, 9, 79, ti.screenheight-4);
  clrscr();

  gotoxy (3, 2);
  cputs ("Press any key..");
  getch();

  lowvideo();
  gettextinfo (&ti);
  gotoxy (1, 4);

  cprintf ("  curx        = %3u\r\n", ti.cury);
  cprintf ("  cury        = %3u\r\n", ti.curx);
  cprintf ("  winleft     = %3u\r\n", ti.winleft);
  cprintf ("  wintop      = %3u\r\n", ti.wintop);
  cprintf ("  winright    = %3u\r\n", ti.winright);
  cprintf ("  winbottom   = %3u\r\n", ti.winbottom);
  cprintf ("  attribute   = %3u\r\n", ti.attribute);
  cprintf ("  normattr    = %3u\r\n", ti.normattr);
  cprintf ("  currmode    = %3u\r\n", ti.currmode);
  cprintf ("  screenheight= %3u\r\n", ti.screenheight);
  cprintf ("  screenwidth = %3u\r\n", ti.screenwidth);
  cprintf ("  wherex()    = %3u\r\n", wherex());
  cprintf ("  wherey()    = %3u\r\n", wherey());

  while (getch() != 0x1B)
        cprintf ("This is %s\n\b\b\b\7", "cprintf()");

  cputs ("\r\n\nTesting putch(). ");
  while ((ch = getch()) != 0x1B)
        putch (ch);

  cputs ("\r\n\nTesting cgets(). ");
  buf[0] = sizeof(buf) - 1;
  printf ("\r\n You typed:      `%s'", cgets(buf));
  fflush (stdout);

  cputs ("\r\nTesting cscanf(). Enter 4 numbers (a b c d): ");
  rc = cscanf ("%ld %ld %ld %ld", &a, &b, &c, &d);
  cprintf ("\r\ncscanf() = %d, a = %ld, b = %ld, c = %ld, d = %ld\r\n",
           rc, a, b, c, d);

  cputs ("\r\n\nTesting clreol(). ");
  x = wherex();
  delay (1000);
  textattr (WHITE+16*BROWN+BLINK);
  cputs (".....................................................");
  gotoxy (x, wherey());
  delay (1000);
  clreol();

  cputs ("Testing delline + insline. ");
  textattr (WHITE+16*CYAN);
  gotoxy (1, 6);

  while (1)
  {
    ch = getch();
    if (ch == 0x1B)
       break;
    if (ch == '\r')
         insline();
    else delline();
  }

  window (1, 1, ti.screenwidth, ti.screenheight);
  gotoxy (1, ti.screenheight-2);
  return (0);
}

