#include "mwutil.h"

#ifndef MSDOS
#error For DOS only
#endif

DWORD FastWrite (int x, int y, int col, const char *str)
{
  register WORD c = (WORD) (col << 8);
  register BYTE ch;

#ifdef PHARLAP
  setup_fs();
#endif

  while ((ch = *str) != '\0')
  {
    switch (ch)
    {
      case '\a':
           soundBell();
           break;

      case '\n':
           ++y;
           break;

      case '\r':
           x = _mw_ti.winleft - 1;
           break;

      case '\b':
           if (x > _mw_ti.winleft-1)
               x--;
           else if (y > _mw_ti.wintop-1)
           {
             y--;
             x = _mw_ti.winright - 1;
           }
           break;

      default:
#ifdef PHARLAP
           moveto_fs (linear_scr + GetVideoOfs(x,y), c + (WORD)ch);
#else
          *(WORD*) (linear_scr + GetVideoOfs(x,y)) = c + (WORD)ch;
#endif
           x++;
    }

    if (x > _mw_ti.winright-1)
    {
      y++;
      x = _mw_ti.winleft - 1;
    }
    if (y > _mw_ti.winbottom-1)
    {
      SCROLL_UP (_mw_ti.winleft, _mw_ti.wintop,
                 _mw_ti.winright,_mw_ti.winbottom, col);
      y--;
    }
    str++;
  }

#ifdef PHARLAP
  restore_fs();
#endif

  return GetVideoOfs(x,y) / 2;
}

