#include "mwutil.h"

void textattr (int attr)
{
  conio_init();
#ifdef WIN32
  attr &= ~BLINK;
#endif
  _mw_ti.attribute = (BYTE)attr;
}

void textcolor (int color)
{
  BYTE bg;
  conio_init();
  bg = (BYTE) _mw_ti.attribute & 0x70;
  _mw_ti.attribute = (color & 0x0F) + bg;
}

void textbackground (int color)
{
  BYTE fg;
  conio_init();
  fg = (BYTE) _mw_ti.attribute & 0x0F;
  _mw_ti.attribute = ((color & 7) << 4) + fg;
}

void highvideo (void)
{
  conio_init();
  _mw_ti.attribute |= 8;
}

void lowvideo (void)
{
  conio_init();
  _mw_ti.attribute &= 0x77;
}

void normvideo(void)
{
  conio_init();
  _mw_ti.attribute = _mw_ti.normattr;
}

/*
 *  for compatibity with djgpp's conio implementation
 */

void blinkvideo (void)  /* Set intensity/blinking bit to BLINKING */
{
#if defined(MSDOS)
  SWI_REGS regs;

  regs.eax = 0x1003;
  regs.eax = 1;
  _dx_real_int (0x10, &regs);
#endif
}

void intensevideo (void) /* Set intensity/blinking bit to INTENSE */
{
#if defined(MSDOS)
  SWI_REGS regs;

  regs.eax = 0x1003;
  regs.ebx = 0;
  _dx_real_int (0x10, &regs);
#endif
}

