#include "mwutil.h"

static void FastWriteCh (int *xp, int *yp, int col, BYTE chr)
{
  int x = *xp;
  int y = *yp;

  if (chr == '\n')
       y++;

  else if (chr == '\r')
       x = _mw_ti.winleft - 1;

  else if (chr == '\b')
  {
    if (x > (int)_mw_ti.winleft - 1)
         x--;
    else if (y > (int)_mw_ti.wintop - 1)
         y--, x = _mw_ti.winleft - 1;
  }

  else if (chr == '\a')
  {
#if defined(MSDOS)
    if (directvideo)
         soundBell();
    else soundBell_BIOS();
#elif defined(WIN32)
    MessageBeep (MB_ICONEXCLAMATION);
#endif
  }

  else if (x < (int)_mw_ti.screenwidth &&
           y < (int)_mw_ti.screenheight)
  {
#if defined(MSDOS)
    if (directvideo)
    {
#ifdef PHARLAP
       *(WORD _far*) (scr_fp + GetVideoOfs(x,y)) = chr + (col << 8);
#else  /* DOS4GW */
       *(WORD*) (GetVideoOfs(x,y) + linear_scr) = chr + (col << 8);
#endif
    }
    else
      write_ch_BIOS (chr,col);

#elif defined(WIN32)
    COORD coord;
    DWORD written;
    WORD  attr = col;

    coord.X = x;
    coord.Y = y + _mw_csbi.srWindow.Top;
    WriteConsoleOutputCharacter (_mw_hStdout, (LPCTSTR)&chr, 1, coord, &written);
    WriteConsoleOutputAttribute (_mw_hStdout, &attr, 1, coord, &written);
#endif
    x++;
  }

  if (x >= (int)_mw_ti.winright)
  {
    x = _mw_ti.winleft - 1;
    y++;
  }

  if (y >= (int)_mw_ti.winbottom)
  {
    if (_wscroll)
       SCROLL_UP (_mw_ti.winleft, _mw_ti.wintop,
                  _mw_ti.winright,_mw_ti.winbottom, col);
    y--;
  }
  *xp = x;
  *yp = y;
}

int putch (int chr)
{
  WORD xy;
  int  x, y;

  conio_init();
  xy = wherexy_abs();
  x = loBYTE (xy);
  y = hiBYTE (xy);

  FastWriteCh (&x, &y, _mw_ti.attribute, chr);
  gotoxy_abs (x, y);
  _mw_ti.cury = y - _mw_ti.wintop  + 2;
  _mw_ti.curx = x - _mw_ti.winleft + 2;
  return (chr);
}

