#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>

#if defined(__HIGHC__) || defined(__WATCOMC__) || defined(WIN32)
#include <mw/conio.h>
#endif

char *Delta_ms (clock_t dt)
{
  static char buf[10];
  double delta = 1000.0 * (double) dt / (double)CLOCKS_PER_SEC;

  sprintf (buf,"%6.1f", delta);
  return (buf);
}


int main (int argc, char **argv)
{
  struct   text_info ti;
  clock_t  start;
  unsigned long i, loops;

#if defined(__HIGHC__) || defined(__WATCOMC__)
  if (argc > 1 && argv[1][0] == 'n')
    _near_screen = 0;
#endif

  directvideo = 1;
  gettextinfo (&ti);
  window (3, 8, 70, ti.screenheight-30);
  textattr (YELLOW+16*BLACK);
  clrscr();
  clock();
  start = clock();

  wherex();
  wherey();

  loops = 10000;
#if !defined(WIN32)   /* WinCon is a snail... */
  loops *= 50;
#endif

  for (i = 0; i < loops; i++)
      cputs ("The quick brown fox jumped over the lazy dog. ");

  cprintf ("\r\nElapsed time ........%s mS\r\n",
           Delta_ms(clock() - start));
  return (0);
}
