include mwutil.ah

_TEXT segment

extrn  @conio_init : near
public _wherex, _wherey, @wherexy_abs

;----------------------------------------------------------------------
; Return cursor positions relative to current winleft/winbottom
;
; int wherex (void);
; int wherey (void);

_wherex: call  @conio_init
         call  @wherexy_abs
         sub   al, @_mw_ti.winleft
         add   al, 2
         mov   @_mw_ti.curx, al
         movzx eax, al
         ret

_wherey: call  @conio_init
         call  @wherexy_abs
         sub   ah, @_mw_ti.wintop
         add   ah, 2
         mov   @_mw_ti.cury, ah
         movzx eax, ah
         ret

;----------------------------------------------------------------------
; wherexy_abs: reads the absolute position of the cursor
; Return: AH = Y (0..49)
;         AL = X (0..131)

         align 4
@wherexy_abs:
ifdef DOS4G
         movzx eax, @screen_page
         movzx eax, word ptr [450h+2*eax]     ; get cursor position
         ret
else
         push  es
         mov   ax, SS_DOSMEM
         mov   es, ax
         movzx eax, @screen_page
         movzx eax, word ptr es:[450h+2*eax]  ; get cursor position
         pop   es
         ret
endif

_TEXT ends
end

